import { ATN, DFA, FailedPredicateException, Parser, RuleContext, ParserRuleContext, TerminalNode, Token, TokenStream } from 'antlr4';
import CircomParserListener from "./CircomParserListener.js";
import CircomParserVisitor from "./CircomParserVisitor.js";
export default class CircomParser extends Parser {
    static readonly VERSION = 1;
    static readonly SIGNAL_TYPE = 2;
    static readonly PRAGMA = 3;
    static readonly CIRCOM = 4;
    static readonly CUSTOM_TEMPLATES = 5;
    static readonly INCLUDE = 6;
    static readonly CUSTOM = 7;
    static readonly PARALLEL = 8;
    static readonly TEMPLATE = 9;
    static readonly FUNCTION = 10;
    static readonly MAIN = 11;
    static readonly PUBLIC = 12;
    static readonly COMPONENT = 13;
    static readonly VAR = 14;
    static readonly SIGNAL = 15;
    static readonly INPUT = 16;
    static readonly OUTPUT = 17;
    static readonly IF = 18;
    static readonly ELSE = 19;
    static readonly FOR = 20;
    static readonly WHILE = 21;
    static readonly DO = 22;
    static readonly LOG = 23;
    static readonly ASSERT = 24;
    static readonly RETURN = 25;
    static readonly LP = 26;
    static readonly RP = 27;
    static readonly LB = 28;
    static readonly RB = 29;
    static readonly LC = 30;
    static readonly RC = 31;
    static readonly SEMICOLON = 32;
    static readonly DOT = 33;
    static readonly COMMA = 34;
    static readonly UNDERSCORE = 35;
    static readonly TERNARY_CONDITION = 36;
    static readonly TERNARY_ALTERNATIVE = 37;
    static readonly EQ_CONSTRAINT = 38;
    static readonly LEFT_CONSTRAINT = 39;
    static readonly RIGHT_CONSTRAINT = 40;
    static readonly SELF_OP = 41;
    static readonly NOT = 42;
    static readonly BNOT = 43;
    static readonly POW = 44;
    static readonly MUL = 45;
    static readonly DIV = 46;
    static readonly QUO = 47;
    static readonly MOD = 48;
    static readonly ADD = 49;
    static readonly SUB = 50;
    static readonly SHL = 51;
    static readonly SHR = 52;
    static readonly BAND = 53;
    static readonly BXOR = 54;
    static readonly BOR = 55;
    static readonly EQ = 56;
    static readonly NEQ = 57;
    static readonly GT = 58;
    static readonly LT = 59;
    static readonly LE = 60;
    static readonly GE = 61;
    static readonly AND = 62;
    static readonly OR = 63;
    static readonly ASSIGNMENT = 64;
    static readonly ASSIGNMENT_WITH_OP = 65;
    static readonly ID = 66;
    static readonly NUMBER = 67;
    static readonly HEX = 68;
    static readonly STRING = 69;
    static readonly COMMENT = 70;
    static readonly LINE_COMMENT = 71;
    static readonly WS = 72;
    static readonly EOF: number;
    static readonly RULE_circuit = 0;
    static readonly RULE_pragmaDeclaration = 1;
    static readonly RULE_includeDeclaration = 2;
    static readonly RULE_blockDeclaration = 3;
    static readonly RULE_functionDeclaration = 4;
    static readonly RULE_functionBlock = 5;
    static readonly RULE_functionStmt = 6;
    static readonly RULE_templateDeclaration = 7;
    static readonly RULE_templateBlock = 8;
    static readonly RULE_componentMainDeclaration = 9;
    static readonly RULE_publicInputsList = 10;
    static readonly RULE_templateStmt = 11;
    static readonly RULE_element = 12;
    static readonly RULE_forControl = 13;
    static readonly RULE_forInit = 14;
    static readonly RULE_forUpdate = 15;
    static readonly RULE_parExpression = 16;
    static readonly RULE_expression = 17;
    static readonly RULE_primary = 18;
    static readonly RULE_logStmt = 19;
    static readonly RULE_componentDefinition = 20;
    static readonly RULE_componentDeclaration = 21;
    static readonly RULE_signalDefinition = 22;
    static readonly RULE_tagList = 23;
    static readonly RULE_signalDeclaration = 24;
    static readonly RULE_varDefinition = 25;
    static readonly RULE_varDeclaration = 26;
    static readonly RULE_rhsValue = 27;
    static readonly RULE_componentCall = 28;
    static readonly RULE_blockInstantiation = 29;
    static readonly RULE_expressionList = 30;
    static readonly RULE_identifier = 31;
    static readonly RULE_arrayDimension = 32;
    static readonly RULE_args = 33;
    static readonly RULE_argsWithUnderscore = 34;
    static readonly RULE_numSequence = 35;
    static readonly literalNames: (string | null)[];
    static readonly symbolicNames: (string | null)[];
    static readonly ruleNames: string[];
    get grammarFileName(): string;
    get literalNames(): (string | null)[];
    get symbolicNames(): (string | null)[];
    get ruleNames(): string[];
    get serializedATN(): number[];
    protected createFailedPredicateException(predicate?: string, message?: string): FailedPredicateException;
    constructor(input: TokenStream);
    circuit(): CircuitContext;
    pragmaDeclaration(): PragmaDeclarationContext;
    includeDeclaration(): IncludeDeclarationContext;
    blockDeclaration(): BlockDeclarationContext;
    functionDeclaration(): FunctionDeclarationContext;
    functionBlock(): FunctionBlockContext;
    functionStmt(): FunctionStmtContext;
    templateDeclaration(): TemplateDeclarationContext;
    templateBlock(): TemplateBlockContext;
    componentMainDeclaration(): ComponentMainDeclarationContext;
    publicInputsList(): PublicInputsListContext;
    templateStmt(): TemplateStmtContext;
    element(): ElementContext;
    forControl(): ForControlContext;
    forInit(): ForInitContext;
    forUpdate(): ForUpdateContext;
    parExpression(): ParExpressionContext;
    expression(): ExpressionContext;
    expression(_p: number): ExpressionContext;
    primary(): PrimaryContext;
    logStmt(): LogStmtContext;
    componentDefinition(): ComponentDefinitionContext;
    componentDeclaration(): ComponentDeclarationContext;
    signalDefinition(): SignalDefinitionContext;
    tagList(): TagListContext;
    signalDeclaration(): SignalDeclarationContext;
    varDefinition(): VarDefinitionContext;
    varDeclaration(): VarDeclarationContext;
    rhsValue(): RhsValueContext;
    componentCall(): ComponentCallContext;
    blockInstantiation(): BlockInstantiationContext;
    expressionList(): ExpressionListContext;
    identifier(): IdentifierContext;
    arrayDimension(): ArrayDimensionContext;
    args(): ArgsContext;
    argsWithUnderscore(): ArgsWithUnderscoreContext;
    numSequence(): NumSequenceContext;
    sempred(localctx: RuleContext, ruleIndex: number, predIndex: number): boolean;
    private expression_sempred;
    static readonly _serializedATN: number[];
    private static __ATN;
    static get _ATN(): ATN;
    static DecisionsToDFA: DFA[];
}
export declare class CircuitContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    EOF(): TerminalNode;
    pragmaDeclaration_list(): PragmaDeclarationContext[];
    pragmaDeclaration(i: number): PragmaDeclarationContext;
    includeDeclaration_list(): IncludeDeclarationContext[];
    includeDeclaration(i: number): IncludeDeclarationContext;
    blockDeclaration_list(): BlockDeclarationContext[];
    blockDeclaration(i: number): BlockDeclarationContext;
    componentMainDeclaration(): ComponentMainDeclarationContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PragmaDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    PRAGMA(): TerminalNode;
    CIRCOM(): TerminalNode;
    VERSION(): TerminalNode;
    SEMICOLON(): TerminalNode;
    CUSTOM_TEMPLATES(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IncludeDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    INCLUDE(): TerminalNode;
    STRING(): TerminalNode;
    SEMICOLON(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BlockDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    functionDeclaration(): FunctionDeclarationContext;
    templateDeclaration(): TemplateDeclarationContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FunctionDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    FUNCTION(): TerminalNode;
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    functionBlock(): FunctionBlockContext;
    args(): ArgsContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FunctionBlockContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LC(): TerminalNode;
    RC(): TerminalNode;
    functionStmt_list(): FunctionStmtContext[];
    functionStmt(i: number): FunctionStmtContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FunctionStmtContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: FunctionStmtContext): void;
}
export declare class ForFuncStmtContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    FOR(): TerminalNode;
    LP(): TerminalNode;
    forControl(): ForControlContext;
    RP(): TerminalNode;
    functionStmt(): FunctionStmtContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class LogFuncStmtContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    logStmt(): LogStmtContext;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FuncVarDeclarationContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    varDeclaration(): VarDeclarationContext;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class AssertFuncStmtContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    ASSERT(): TerminalNode;
    parExpression(): ParExpressionContext;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FuncBlockContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    functionBlock(): FunctionBlockContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FuncSelfOpContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    ID(): TerminalNode;
    SELF_OP(): TerminalNode;
    SEMICOLON(): TerminalNode;
    arrayDimension_list(): ArrayDimensionContext[];
    arrayDimension(i: number): ArrayDimensionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IfFuncStmtContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    IF(): TerminalNode;
    parExpression(): ParExpressionContext;
    functionStmt_list(): FunctionStmtContext[];
    functionStmt(i: number): FunctionStmtContext;
    ELSE(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class WhileFuncStmtContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    WHILE(): TerminalNode;
    parExpression(): ParExpressionContext;
    functionStmt(): FunctionStmtContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ReturnFuncStmtContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    RETURN(): TerminalNode;
    expression(): ExpressionContext;
    SEMICOLON(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FuncVariadicAssignmentContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    LP_list(): TerminalNode[];
    LP(i: number): TerminalNode;
    argsWithUnderscore(): ArgsWithUnderscoreContext;
    RP_list(): TerminalNode[];
    RP(i: number): TerminalNode;
    ASSIGNMENT(): TerminalNode;
    SEMICOLON(): TerminalNode;
    expressionList(): ExpressionListContext;
    expression(): ExpressionContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class FuncAssignmentExpressionContext extends FunctionStmtContext {
    constructor(parser: CircomParser, ctx: FunctionStmtContext);
    identifier(): IdentifierContext;
    expression(): ExpressionContext;
    SEMICOLON(): TerminalNode;
    ASSIGNMENT(): TerminalNode;
    ASSIGNMENT_WITH_OP(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class TemplateDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    TEMPLATE(): TerminalNode;
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    templateBlock(): TemplateBlockContext;
    CUSTOM(): TerminalNode;
    PARALLEL(): TerminalNode;
    args(): ArgsContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class TemplateBlockContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LC(): TerminalNode;
    RC(): TerminalNode;
    templateStmt_list(): TemplateStmtContext[];
    templateStmt(i: number): TemplateStmtContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ComponentMainDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    COMPONENT(): TerminalNode;
    MAIN(): TerminalNode;
    ASSIGNMENT(): TerminalNode;
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    SEMICOLON(): TerminalNode;
    publicInputsList(): PublicInputsListContext;
    expressionList(): ExpressionListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PublicInputsListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LC(): TerminalNode;
    PUBLIC(): TerminalNode;
    LB(): TerminalNode;
    args(): ArgsContext;
    RB(): TerminalNode;
    RC(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class TemplateStmtContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    templateBlock(): TemplateBlockContext;
    ID(): TerminalNode;
    SELF_OP(): TerminalNode;
    SEMICOLON(): TerminalNode;
    arrayDimension_list(): ArrayDimensionContext[];
    arrayDimension(i: number): ArrayDimensionContext;
    varDeclaration(): VarDeclarationContext;
    signalDeclaration(): SignalDeclarationContext;
    componentDeclaration(): ComponentDeclarationContext;
    blockInstantiation(): BlockInstantiationContext;
    identifier(): IdentifierContext;
    ASSIGNMENT(): TerminalNode;
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    EQ_CONSTRAINT(): TerminalNode;
    element_list(): ElementContext[];
    element(i: number): ElementContext;
    LEFT_CONSTRAINT(): TerminalNode;
    ASSIGNMENT_WITH_OP(): TerminalNode;
    LP_list(): TerminalNode[];
    LP(i: number): TerminalNode;
    RP_list(): TerminalNode[];
    RP(i: number): TerminalNode;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    RIGHT_CONSTRAINT(): TerminalNode;
    UNDERSCORE(): TerminalNode;
    argsWithUnderscore(): ArgsWithUnderscoreContext;
    expressionList(): ExpressionListContext;
    IF(): TerminalNode;
    parExpression(): ParExpressionContext;
    templateStmt_list(): TemplateStmtContext[];
    templateStmt(i: number): TemplateStmtContext;
    ELSE(): TerminalNode;
    WHILE(): TerminalNode;
    FOR(): TerminalNode;
    forControl(): ForControlContext;
    ASSERT(): TerminalNode;
    logStmt(): LogStmtContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ElementContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    identifier_list(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    DOT(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ForControlContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    forInit(): ForInitContext;
    SEMICOLON_list(): TerminalNode[];
    SEMICOLON(i: number): TerminalNode;
    expression(): ExpressionContext;
    forUpdate(): ForUpdateContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ForInitContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    identifier(): IdentifierContext;
    VAR(): TerminalNode;
    ASSIGNMENT(): TerminalNode;
    rhsValue(): RhsValueContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ForUpdateContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID(): TerminalNode;
    SELF_OP(): TerminalNode;
    expression(): ExpressionContext;
    ASSIGNMENT(): TerminalNode;
    ASSIGNMENT_WITH_OP(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ParExpressionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LP(): TerminalNode;
    expression(): ExpressionContext;
    RP(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ExpressionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    get ruleIndex(): number;
    copyFrom(ctx: ExpressionContext): void;
}
export declare class TernaryExpressionContext extends ExpressionContext {
    constructor(parser: CircomParser, ctx: ExpressionContext);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    TERNARY_CONDITION(): TerminalNode;
    TERNARY_ALTERNATIVE(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class DotExpressionContext extends ExpressionContext {
    constructor(parser: CircomParser, ctx: ExpressionContext);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    DOT(): TerminalNode;
    ID(): TerminalNode;
    LB(): TerminalNode;
    RB(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PrimaryExpressionContext extends ExpressionContext {
    constructor(parser: CircomParser, ctx: ExpressionContext);
    primary(): PrimaryContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BinaryExpressionContext extends ExpressionContext {
    _op: Token;
    constructor(parser: CircomParser, ctx: ExpressionContext);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    POW(): TerminalNode;
    MUL(): TerminalNode;
    DIV(): TerminalNode;
    QUO(): TerminalNode;
    MOD(): TerminalNode;
    ADD(): TerminalNode;
    SUB(): TerminalNode;
    SHL(): TerminalNode;
    SHR(): TerminalNode;
    BAND(): TerminalNode;
    BXOR(): TerminalNode;
    BOR(): TerminalNode;
    EQ(): TerminalNode;
    NEQ(): TerminalNode;
    GT(): TerminalNode;
    LT(): TerminalNode;
    GE(): TerminalNode;
    LE(): TerminalNode;
    AND(): TerminalNode;
    OR(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BlockInstantiationExpressionContext extends ExpressionContext {
    constructor(parser: CircomParser, ctx: ExpressionContext);
    blockInstantiation(): BlockInstantiationContext;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class UnaryExpressionContext extends ExpressionContext {
    _op: Token;
    constructor(parser: CircomParser, ctx: ExpressionContext);
    expression(): ExpressionContext;
    BNOT(): TerminalNode;
    NOT(): TerminalNode;
    SUB(): TerminalNode;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class PrimaryContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LP(): TerminalNode;
    expression(): ExpressionContext;
    RP(): TerminalNode;
    LB(): TerminalNode;
    expressionList(): ExpressionListContext;
    RB(): TerminalNode;
    NUMBER(): TerminalNode;
    identifier(): IdentifierContext;
    args(): ArgsContext;
    numSequence(): NumSequenceContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class LogStmtContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LOG(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    STRING_list(): TerminalNode[];
    STRING(i: number): TerminalNode;
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ComponentDefinitionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    COMPONENT(): TerminalNode;
    ID(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ComponentDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    componentDefinition(): ComponentDefinitionContext;
    arrayDimension_list(): ArrayDimensionContext[];
    arrayDimension(i: number): ArrayDimensionContext;
    ASSIGNMENT(): TerminalNode;
    blockInstantiation(): BlockInstantiationContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SignalDefinitionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    SIGNAL(): TerminalNode;
    identifier(): IdentifierContext;
    SIGNAL_TYPE(): TerminalNode;
    tagList(): TagListContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class TagListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LC(): TerminalNode;
    args(): ArgsContext;
    RC(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class SignalDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    signalDefinition(): SignalDefinitionContext;
    LEFT_CONSTRAINT(): TerminalNode;
    rhsValue(): RhsValueContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    identifier_list(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class VarDefinitionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    VAR(): TerminalNode;
    identifier_list(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    LP(): TerminalNode;
    RP(): TerminalNode;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class VarDeclarationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    varDefinition(): VarDefinitionContext;
    ASSIGNMENT(): TerminalNode;
    rhsValue(): RhsValueContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    identifier_list(): IdentifierContext[];
    identifier(i: number): IdentifierContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class RhsValueContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LP(): TerminalNode;
    expressionList(): ExpressionListContext;
    RP(): TerminalNode;
    expression(): ExpressionContext;
    blockInstantiation(): BlockInstantiationContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ComponentCallContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LP(): TerminalNode;
    RP(): TerminalNode;
    expressionList(): ExpressionListContext;
    ID_list(): TerminalNode[];
    ID(i: number): TerminalNode;
    LEFT_CONSTRAINT_list(): TerminalNode[];
    LEFT_CONSTRAINT(i: number): TerminalNode;
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    RIGHT_CONSTRAINT_list(): TerminalNode[];
    RIGHT_CONSTRAINT(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class BlockInstantiationContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID(): TerminalNode;
    LP(): TerminalNode;
    RP(): TerminalNode;
    PARALLEL(): TerminalNode;
    expressionList(): ExpressionListContext;
    componentCall(): ComponentCallContext;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ExpressionListContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    expression_list(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class IdentifierContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID_list(): TerminalNode[];
    ID(i: number): TerminalNode;
    arrayDimension_list(): ArrayDimensionContext[];
    arrayDimension(i: number): ArrayDimensionContext;
    DOT(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ArrayDimensionContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    LB(): TerminalNode;
    expression(): ExpressionContext;
    RB(): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ArgsContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    ID_list(): TerminalNode[];
    ID(i: number): TerminalNode;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class ArgsWithUnderscoreContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    UNDERSCORE_list(): TerminalNode[];
    UNDERSCORE(i: number): TerminalNode;
    ID_list(): TerminalNode[];
    ID(i: number): TerminalNode;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
export declare class NumSequenceContext extends ParserRuleContext {
    constructor(parser?: CircomParser, parent?: ParserRuleContext, invokingState?: number);
    NUMBER_list(): TerminalNode[];
    NUMBER(i: number): TerminalNode;
    COMMA_list(): TerminalNode[];
    COMMA(i: number): TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: CircomParserListener): void;
    exitRule(listener: CircomParserListener): void;
    accept<Result>(visitor: CircomParserVisitor<Result>): Result;
}
//# sourceMappingURL=CircomParser.d.ts.map